/*********************************************************************************************************/
/*** 			                    	Benjamin Fletcher - bjf1g13                                    ***/
/*** 	                        Power Neutral Energy Harvesting Management                             ***/
/*** 	                              for Multicore Embedded systems                                   ***/
/*** 	                                                                                               ***/
/*** 	                                       core_switch.h                                           ***/
/*** 	                                                                                               ***/
/*** 	                              (see report for documentation)                                   ***/
/*********************************************************************************************************/

#define INSTRUCTION_LENGTH 64

int turn_off_core(int core)
{
	if(0 < core < 8)
	{
		int fd;
		char instruction[INSTRUCTION_LENGTH] = {};
		sprintf(instruction, "/sys/devices/system/cpu/cpu%d/online", core);	
		fd = open(instruction, O_WRONLY);
		write(fd, "0", 1);
		close(fd);	

		return 0;
	}
	else
		return -1;
}

int turn_on_core(int core)
{
	if(0 < core < 8)
	{
		int fd;
		char instruction[INSTRUCTION_LENGTH] = {};
		sprintf(instruction, "/sys/devices/system/cpu/cpu%d/online", core);	
		fd = open(instruction, O_WRONLY);
		write(fd, "1", 1);
		close(fd);	
	}
	else
		return -1;
}



