/*********************************************************************************************************/
/*** 			                    	Benjamin Fletcher - bjf1g13                                    ***/
/*** 	                        Power Neutral Energy Harvesting Management                             ***/
/*** 	                              for Multicore Embedded systems                                   ***/
/*** 	                                                                                               ***/
/*** 	                                   frequency_switch.h                                          ***/
/*** 	                                                                                               ***/
/*** 	                              (see report for documentation)                                   ***/
/*********************************************************************************************************/

void frequency_switch_init(void)
{
	struct cpufreq_policy default_policy;
	const char * default_policy_governor = "powersave";
	default_policy.governor = strdup(default_policy_governor);
	default_policy.min      = 1400000;
	default_policy.max      = 1400000;

	for(int n = 0; n < 5; n+=4)
		cpufreq_set_policy(n, &default_policy);

}

void set_A_cores_frequency(unsigned long frequency)
{
	cpufreq_modify_policy_min(0, frequency/1000);
}

void set_B_cores_frequency(unsigned long frequency)
{
	cpufreq_modify_policy_min(4, frequency/1000);
}



